// -*-C++-*-
/*!
 * @file  ManipulatorCommonInterface_CommonSVC_impl.h
 * @brief Service implementation header of ManipulatorCommonInterface_Common.idl
 *
 */

#include "ManipulatorCommonInterface_DataTypesSkel.h"
#include "BasicDataTypeSkel.h"

#include "ManipulatorCommonInterface_CommonSkel.h"

#ifndef MANIPULATORCOMMONINTERFACE_COMMONSVC_IMPL_H
#define MANIPULATORCOMMONINTERFACE_COMMONSVC_IMPL_H
 
/*!
 * @class ManipulatorCommonInterface_CommonSVC_impl
 * Example class implementing IDL interface ManipulatorCommonInterface_Common
 */
class ManipulatorCommonInterface_CommonSVC_impl
 : public virtual POA_ManipulatorCommonInterface_Common,
   public virtual PortableServer::RefCountServantBase
{
 private:
   // Make sure all instances are built on the heap by making the
   // destructor non-public
   //virtual ~ManipulatorCommonInterface_CommonSVC_impl();

 public:
  /*!
   * @brief standard constructor
   */
   ManipulatorCommonInterface_CommonSVC_impl();
  /*!
   * @brief destructor
   */
   virtual ~ManipulatorCommonInterface_CommonSVC_impl();

   // attributes and operations
   RETURN_ID* clearAlarms();
   RETURN_ID* getActiveAlarm(AlarmSeq_out alarms);
   RETURN_ID* getFeedbackPosJoint(JointPos_out pos);
   RETURN_ID* getManipInfo(ManipInfo_out mInfo);
   RETURN_ID* getSoftLimitJoint(LimitSeq_out softLimit);
   RETURN_ID* getState(ULONG& state);
   RETURN_ID* servoOFF();
   RETURN_ID* servoON();
   RETURN_ID* setSoftLimitJoint(const LimitSeq& softLimit);

   private:
		ULONG m_state;
   public:
		ULONG stateData(){
			return m_state;
		}

};



#endif // MANIPULATORCOMMONINTERFACE_COMMONSVC_IMPL_H


