// -*-C++-*-
/*!
 * @file  ManipulatorCommonInterface_MiddleLevelSVC_impl.cpp
 * @brief Service implementation code of ManipulatorCommonInterface_MiddleLevel.idl
 *
 */

#include "ManipulatorCommonInterface_MiddleLevelSVC_impl.h"
#include "defreturnid.h"
#include "message.h"
#include <iostream>

/*
 * Example implementational code for IDL interface ManipulatorCommonInterface_Middle
 */
ManipulatorCommonInterface_MiddleSVC_impl::ManipulatorCommonInterface_MiddleSVC_impl()
{
  // Please add extra constructor code here.
}


ManipulatorCommonInterface_MiddleSVC_impl::~ManipulatorCommonInterface_MiddleSVC_impl()
{
  // Please add extra destructor code here.
}

//O[oϐ
int iMiddle,jMiddle;
double BufMiddle[13];
double FileBufMiddle[20];

//TimeStamp
SYSTEMTIME TimeStampMiddle1,TimeStampMiddle2;

//t@C|C^
FILE *fpMiddle;
//}js[^̐ݒʒu
HgMatrix BaseOffset;
//tWʃItZbg
HgMatrix FlangeOffset;
//𓮍쎞̍ő哮쑬x
//static double MaxTranV,MaxRotV;
CartesianSpeed MaxCV;
//֐ߓ쎞̍ő哮쑬x
static double MaxJV[5];
//֐ߓ쎞̍ŏ
static double MinAccelTimeC;
//𓮍쎞̍ŏ
static double MinAccelTimeJ;
//Wñ\tg~bg
static double MinLimitX,MinLimitY,MinLimitZ,MaxLimitX,MaxLimitY,MaxLimitZ;
//z[|WV
double HomePoint[4];


/*
 * Methods corresponding to IDL attributes and operations
 */
RETURN_ID* ManipulatorCommonInterface_MiddleSVC_impl::closeGripper()
{
	for(iMiddle=0;iMiddle<13;iMiddle++){
		BufMiddle[iMiddle]=0.0;
	}
	BufMiddle[0]=201;
	Message(BufMiddle);
	RETURNID_OK;
}

RETURN_ID* ManipulatorCommonInterface_MiddleSVC_impl::getBaseOffset(HgMatrix offset)
{
	for(iMiddle=0;iMiddle<13;iMiddle++){
		BufMiddle[iMiddle]=0.0;
	}
	offset=BaseOffset;

	RETURNID_OK;
}

RETURN_ID* ManipulatorCommonInterface_MiddleSVC_impl::getFeedbackPosCartesian(CarPosWithElbow& pos)
{
	//TimeStampMiddle1̑
	GetLocalTime(&TimeStampMiddle1);

	for(iMiddle=0;iMiddle<13;iMiddle++){
		BufMiddle[iMiddle]=0.0;
	}
	BufMiddle[0]=203;
	Message(BufMiddle);

	//҂Ԃ
	Sleep(10);

	//t@CI[v
	fpMiddle=fopen( "../../Info.dat", "r");
	//ǂݍ
	fscanf(fpMiddle, "%lf,%lf,%lf,%lf,%lf,%lf", &FileBufMiddle[0], &FileBufMiddle[1], &FileBufMiddle[2], &FileBufMiddle[3], &FileBufMiddle[4], &FileBufMiddle[5]);//WʒuEp
	fscanf(fpMiddle, "%lf,%lf,%lf,%lf,%lf", &FileBufMiddle[6], &FileBufMiddle[7], &FileBufMiddle[8], &FileBufMiddle[9], &FileBufMiddle[10], &FileBufMiddle[11], &FileBufMiddle[12]);//֐ߍWEObp
	fscanf(fpMiddle, "%lf,%lf,%lf,%lf,%lf,%lf", &FileBufMiddle[13], &FileBufMiddle[14], &FileBufMiddle[15], &FileBufMiddle[16], &FileBufMiddle[17], &FileBufMiddle[18]);//G[
	fscanf(fpMiddle, "%d,%d,%d,%d,%d,%d,%d", &TimeStampMiddle2.wYear, &TimeStampMiddle2.wMonth, &TimeStampMiddle2.wDay, &TimeStampMiddle2.wHour, &TimeStampMiddle2.wMinute, &TimeStampMiddle2.wSecond,&TimeStampMiddle2.wMilliseconds);//TimeStamp
	//t@C
	fclose(fpMiddle);

	//TimeStamp̕]
	if(TimeStampMiddle1.wYear==TimeStampMiddle2.wYear){
		if(TimeStampMiddle1.wMonth==TimeStampMiddle2.wMonth){
			if(TimeStampMiddle1.wDay==TimeStampMiddle2.wDay){
				if(TimeStampMiddle1.wHour==TimeStampMiddle2.wHour){
					if(TimeStampMiddle1.wMinute==TimeStampMiddle2.wMinute){
						if(TimeStampMiddle1.wSecond==TimeStampMiddle2.wSecond){
							if(TimeStampMiddle1.wMilliseconds==TimeStampMiddle2.wMilliseconds){
								RETURNID_STATUS_ERR
							}else if(TimeStampMiddle1.wMilliseconds>TimeStampMiddle2.wMilliseconds){
								RETURNID_STATUS_ERR
							}
						}else if(TimeStampMiddle1.wSecond>TimeStampMiddle2.wSecond){
							RETURNID_STATUS_ERR
						}
					}else if(TimeStampMiddle1.wMinute>TimeStampMiddle2.wMinute){
						RETURNID_STATUS_ERR
					}
				}else if(TimeStampMiddle1.wHour>TimeStampMiddle2.wHour){
					RETURNID_STATUS_ERR
				}
			}else if(TimeStampMiddle1.wDay>TimeStampMiddle2.wDay){
				RETURNID_STATUS_ERR
			}
		}else if(TimeStampMiddle1.wMonth>TimeStampMiddle2.wMonth){
			RETURNID_STATUS_ERR
		}
	}else if(TimeStampMiddle1.wYear>TimeStampMiddle2.wYear){
		RETURNID_STATUS_ERR
	}


	//deg->redϊ
	FileBufMiddle[3]=FileBufMiddle[3]/180.0*M_PI;
	FileBufMiddle[4]=FileBufMiddle[4]/180.0*M_PI;
	FileBufMiddle[5]=FileBufMiddle[5]/180.0*M_PI;

	//datt@C̎pZ->Y->X]ł̒l
	//1s
	pos.carPos[0][0]=cos(FileBufMiddle[5])*cos(FileBufMiddle[4]);
	pos.carPos[0][1]=sin(FileBufMiddle[5])*cos(FileBufMiddle[4]);
	pos.carPos[0][2]=-sin(FileBufMiddle[4]);
	pos.carPos[0][3]=FileBufMiddle[0];

	//2s
	pos.carPos[1][0]=-sin(FileBufMiddle[5])*cos(FileBufMiddle[3])+cos(FileBufMiddle[5])*sin(FileBufMiddle[4])*sin(FileBufMiddle[3]);
	pos.carPos[1][1]=cos(FileBufMiddle[5])*cos(FileBufMiddle[3])+sin(FileBufMiddle[5])*sin(FileBufMiddle[4])*sin(FileBufMiddle[3]);
	pos.carPos[1][2]=cos(FileBufMiddle[4])*sin(FileBufMiddle[3]);
	pos.carPos[1][3]=FileBufMiddle[1];

	//3s
	pos.carPos[2][0]=sin(FileBufMiddle[5])*sin(FileBufMiddle[3])+cos(FileBufMiddle[5])*sin(FileBufMiddle[4])*cos(FileBufMiddle[3]);
	pos.carPos[2][1]=-cos(FileBufMiddle[5])*sin(FileBufMiddle[3])+sin(FileBufMiddle[5])*sin(FileBufMiddle[4])*cos(FileBufMiddle[3]);
	pos.carPos[2][2]=cos(FileBufMiddle[4])*cos(FileBufMiddle[3]);
	pos.carPos[2][3]=FileBufMiddle[2];
	
	RETURNID_OK;
}

RETURN_ID* ManipulatorCommonInterface_MiddleSVC_impl::getMaxSpeedCartesian(CartesianSpeed& speed)
{
	speed=MaxCV;
	RETURNID_OK;
}

RETURN_ID* ManipulatorCommonInterface_MiddleSVC_impl::getMaxSpeedJoint(DoubleSeq_out speed)
{
	speed=new DoubleSeq;
	speed->length(7);//nhL
	for(iMiddle=0;iMiddle<7;iMiddle++){
		(*speed)[iMiddle]=MaxJV[iMiddle];
	}
	RETURNID_OK;
}

RETURN_ID* ManipulatorCommonInterface_MiddleSVC_impl::getMinAccelTimeCartesian(CORBA::Double& aclTime)
{
	aclTime=MinAccelTimeJ;
	RETURNID_OK;
}

RETURN_ID* ManipulatorCommonInterface_MiddleSVC_impl::getMinAccelTimeJoint(CORBA::Double& aclTime)
{
	aclTime=MinAccelTimeC;
	RETURNID_OK;
}

RETURN_ID* ManipulatorCommonInterface_MiddleSVC_impl::getSoftLimitCartesian(LimitValue& xLimit, LimitValue& yLimit, LimitValue& zLimit)
{
	xLimit.upper=MaxLimitX;
	xLimit.lower=MinLimitX;
	yLimit.upper=MaxLimitY;
	yLimit.lower=MinLimitY;
	zLimit.upper=MaxLimitZ;
	zLimit.lower=MinLimitZ;
	RETURNID_OK;
}

RETURN_ID* ManipulatorCommonInterface_MiddleSVC_impl::moveGripper(ULONG angleRatio)
{
	for(iMiddle=0;iMiddle<13;iMiddle++){
		BufMiddle[iMiddle]=0.0;
	}
	BufMiddle[0]=209;
	BufMiddle[1]=angleRatio;
	if(BufMiddle[1]>100){
		//s
		RETURNID_VALUE_ERR;
	}
	//100{đM
	BufMiddle[1]=BufMiddle[1]*100;
	Message(BufMiddle);
	RETURNID_OK;
}

RETURN_ID* ManipulatorCommonInterface_MiddleSVC_impl::moveLinearCartesianAbs(const CarPosWithElbow& carPoint)
{
	for(iMiddle=0;iMiddle<13;iMiddle++){
		BufMiddle[iMiddle]=0.0;
	}
	BufMiddle[0]=210;
	BufMiddle[1]=carPoint.carPos[0][3];//x
	BufMiddle[2]=carPoint.carPos[1][3];//y
	BufMiddle[3]=carPoint.carPos[2][3];//z
	BufMiddle[5]=180.0-asin(-carPoint.carPos[0][2])*180.0/M_PI;//B(90`180deg͈̔)
	if(fabs(BufMiddle[5])==90){
		BufMiddle[4]=0.0;//A
		BufMiddle[6]=atan2(carPoint.carPos[1][1],carPoint.carPos[0][1])*180.0/M_PI;//C
	}else{
		BufMiddle[4]=atan2(carPoint.carPos[1][2],carPoint.carPos[2][2])*180.0/M_PI;//A
		BufMiddle[6]=atan2(carPoint.carPos[0][1],carPoint.carPos[0][0])*180.0/M_PI;//C
	}
	//100{đM
	for(iMiddle=1;iMiddle<7;iMiddle++){
		BufMiddle[iMiddle]=BufMiddle[iMiddle]*100;
	}
	Message(BufMiddle);

	RETURNID_OK;
}

RETURN_ID* ManipulatorCommonInterface_MiddleSVC_impl::moveLinearCartesianRel(const CarPosWithElbow& carPoint)
{
	for(iMiddle=0;iMiddle<13;iMiddle++){
		BufMiddle[iMiddle]=0.0;
	}
	BufMiddle[0]=211;
	BufMiddle[1]=carPoint.carPos[0][3];//x
	BufMiddle[2]=carPoint.carPos[1][3];//y
	BufMiddle[3]=carPoint.carPos[2][3];//z
	BufMiddle[5]=asin(-carPoint.carPos[0][2])*180.0/M_PI;//B
	if(fabs(BufMiddle[5])==90){
		BufMiddle[4]=0.0;//A
		BufMiddle[6]=atan2(carPoint.carPos[1][1],carPoint.carPos[0][1])*180.0/M_PI;//C
	}else{
		BufMiddle[4]=atan2(carPoint.carPos[1][2],carPoint.carPos[2][2])*180.0/M_PI;//A
		BufMiddle[6]=atan2(carPoint.carPos[0][1],carPoint.carPos[0][0])*180.0/M_PI;//C
	}

	//100{đM
	for(iMiddle=1;iMiddle<7;iMiddle++){
		BufMiddle[iMiddle]=BufMiddle[iMiddle]*100;
	}
	Message(BufMiddle);
	RETURNID_OK;
}

RETURN_ID* ManipulatorCommonInterface_MiddleSVC_impl::movePTPCartesianAbs(const CarPosWithElbow& carPoint)
{
	for(iMiddle=0;iMiddle<13;iMiddle++){
		BufMiddle[iMiddle]=0.0;
	}
	BufMiddle[0]=212;
	BufMiddle[1]=carPoint.carPos[0][3];//x
	BufMiddle[2]=carPoint.carPos[1][3];//y
	BufMiddle[3]=carPoint.carPos[2][3];//z
	BufMiddle[5]=180.0-asin(-carPoint.carPos[0][2])*180.0/M_PI;//B(90`180deg͈̔)

	if(fabs(BufMiddle[5])==90){
		BufMiddle[4]=0.0;//A
		BufMiddle[6]=atan2(carPoint.carPos[1][1],carPoint.carPos[0][1])*180.0/M_PI;//C
	}else{
		BufMiddle[4]=atan2(carPoint.carPos[1][2],carPoint.carPos[2][2])*180.0/M_PI;//A
		BufMiddle[6]=atan2(carPoint.carPos[0][1],carPoint.carPos[0][0])*180.0/M_PI;//C
	}

	//100{đM
	for(iMiddle=1;iMiddle<7;iMiddle++){
		BufMiddle[iMiddle]=BufMiddle[iMiddle]*100;
	}
	Message(BufMiddle);

	RETURNID_OK;
}

RETURN_ID* ManipulatorCommonInterface_MiddleSVC_impl::movePTPCartesianRel(const CarPosWithElbow& carPoint)
{
	for(iMiddle=0;iMiddle<13;iMiddle++){
		BufMiddle[iMiddle]=0.0;
	}
	BufMiddle[0]=213;
	BufMiddle[1]=carPoint.carPos[0][3];//x
	BufMiddle[2]=carPoint.carPos[1][3];//y
	BufMiddle[3]=carPoint.carPos[2][3];//z
	BufMiddle[5]=asin(-carPoint.carPos[0][2])*180.0/M_PI;//B
	if(fabs(BufMiddle[5])==90){
		BufMiddle[4]=0.0;//A
		BufMiddle[6]=atan2(carPoint.carPos[1][1],carPoint.carPos[0][1])*180.0/M_PI;//C
	}else{
		BufMiddle[4]=atan2(carPoint.carPos[1][2],carPoint.carPos[2][2])*180.0/M_PI;//A
		BufMiddle[6]=atan2(carPoint.carPos[0][1],carPoint.carPos[0][0])*180.0/M_PI;//C
	}

	//100{đM
	for(iMiddle=1;iMiddle<7;iMiddle++){
		BufMiddle[iMiddle]=BufMiddle[iMiddle]*100;
	}
	Message(BufMiddle);
	RETURNID_OK;
}

RETURN_ID* ManipulatorCommonInterface_MiddleSVC_impl::movePTPJointAbs(const JointPos& jointPoints)
{
	for(iMiddle=0;iMiddle<13;iMiddle++){
		BufMiddle[iMiddle]=0.0;
	}
	BufMiddle[0]=214;
	for(iMiddle=0;iMiddle<6;iMiddle++){
		BufMiddle[iMiddle+1]=jointPoints[iMiddle];
	}

	//100{đM
	for(iMiddle=1;iMiddle<7;iMiddle++){
		BufMiddle[iMiddle]=BufMiddle[iMiddle]*100;
	}
	Message(BufMiddle);

	RETURNID_OK;
}

RETURN_ID* ManipulatorCommonInterface_MiddleSVC_impl::movePTPJointRel(const JointPos& jointPoints)
{
	for(iMiddle=0;iMiddle<13;iMiddle++){
		BufMiddle[iMiddle]=0.0;
	}
	BufMiddle[0]=215;
	for(iMiddle=0;iMiddle<6;iMiddle++){
		BufMiddle[iMiddle+1]=jointPoints[iMiddle];
	}

	//100{đM
	for(iMiddle=1;iMiddle<7;iMiddle++){
		BufMiddle[iMiddle]=BufMiddle[iMiddle]*100;
	}
	Message(BufMiddle);

	RETURNID_OK;
}

RETURN_ID* ManipulatorCommonInterface_MiddleSVC_impl::openGripper()
{
	for(iMiddle=0;iMiddle<13;iMiddle++){
		BufMiddle[iMiddle]=0.0;
	}
	BufMiddle[0]=216;
	Message(BufMiddle);
	RETURNID_OK;
}

RETURN_ID* ManipulatorCommonInterface_MiddleSVC_impl::pause()
{
	for(iMiddle=0;iMiddle<13;iMiddle++){
		BufMiddle[iMiddle]=0.0;
	}
	BufMiddle[0]=217;
	Message(BufMiddle);
	RETURNID_OK;
}

RETURN_ID* ManipulatorCommonInterface_MiddleSVC_impl::resume()
{
	for(iMiddle=0;iMiddle<13;iMiddle++){
		BufMiddle[iMiddle]=0.0;
	}
	BufMiddle[0]=218;
	Message(BufMiddle);
	RETURNID_OK;
}

RETURN_ID* ManipulatorCommonInterface_MiddleSVC_impl::stop()
{
	for(iMiddle=0;iMiddle<13;iMiddle++){
		BufMiddle[iMiddle]=0.0;
	}
	BufMiddle[0]=219;
	Message(BufMiddle);
	RETURNID_OK;
}

RETURN_ID* ManipulatorCommonInterface_MiddleSVC_impl::setAccelTimeCartesian(CORBA::Double aclTime)
{
	for(iMiddle=0;iMiddle<13;iMiddle++){
		BufMiddle[iMiddle]=0.0;
	}
	BufMiddle[0]=220;
	BufMiddle[1]=aclTime;
	//100{đM
	BufMiddle[1]=BufMiddle[1]*100;
	Message(BufMiddle);
	
	MinAccelTimeC=aclTime;

	RETURNID_OK;
}

RETURN_ID* ManipulatorCommonInterface_MiddleSVC_impl::setAccelTimeJoint(CORBA::Double aclTime)
{
	for(iMiddle=0;iMiddle<13;iMiddle++){
		BufMiddle[iMiddle]=0.0;
	}
	BufMiddle[0]=221;
	BufMiddle[1]=aclTime;
	//100{đM
	BufMiddle[1]=BufMiddle[1]*100;
	Message(BufMiddle);

	MinAccelTimeJ=aclTime;

	RETURNID_OK;
}

RETURN_ID* ManipulatorCommonInterface_MiddleSVC_impl::setBaseOffset(const HgMatrix offset)
{
	for(iMiddle=0;iMiddle<13;iMiddle++){
		BufMiddle[iMiddle]=0.0;
	}
	BufMiddle[0]=222;
	BufMiddle[1]=offset[0][3];//x
	BufMiddle[2]=offset[1][3];//y
	BufMiddle[3]=offset[2][3];//z

	BufMiddle[5]=asin(-offset[0][2])*180.0/M_PI;//B[deg]
	if((BufMiddle[5]==90)||(BufMiddle[5]==-90)){
		BufMiddle[4]=0.0;//A[deg]
		BufMiddle[6]=atan2(offset[1][1],offset[0][1])*180.0/M_PI;//C[deg]
	}else{
		BufMiddle[4]=atan2(offset[1][2],offset[2][2])*180.0/M_PI;//A[deg]
		BufMiddle[6]=atan2(offset[0][1],offset[0][0])*180.0/M_PI;//C[deg]
	}

	//100{đM
	for(iMiddle=1;iMiddle<7;iMiddle++){
		BufMiddle[iMiddle]=BufMiddle[iMiddle]*100;
	}
	Message(BufMiddle);

	for(iMiddle=0;iMiddle<4;iMiddle++){
		for(jMiddle=0;jMiddle<3;jMiddle++){
			BaseOffset[jMiddle][iMiddle]=offset[jMiddle][iMiddle];
		}
	}
	

	RETURNID_OK;
}

RETURN_ID* ManipulatorCommonInterface_MiddleSVC_impl::setControlPointOffset(const HgMatrix offset)
{
	for(iMiddle=0;iMiddle<13;iMiddle++){
		BufMiddle[iMiddle]=0.0;
	}
	BufMiddle[0]=223;
	BufMiddle[1]=offset[0][3];//x
	BufMiddle[2]=offset[1][3];//y
	BufMiddle[3]=offset[2][3];//z

	BufMiddle[5]=asin(-offset[0][2])*180.0/M_PI;//B[deg]
	if((BufMiddle[5]==90)||(BufMiddle[5]==-90)){
		BufMiddle[4]=0.0;//A[deg]
		BufMiddle[6]=atan2(offset[1][1],offset[0][1])*180.0/M_PI;//C[deg]
	}else{
		BufMiddle[4]=atan2(offset[1][2],offset[2][2])*180.0/M_PI;//A[deg]
		BufMiddle[6]=atan2(offset[0][1],offset[0][0])*180.0/M_PI;//C[deg]
	}

	//100{đM
	for(iMiddle=1;iMiddle<7;iMiddle++){
		BufMiddle[iMiddle]=BufMiddle[iMiddle]*100;
	}
	Message(BufMiddle);

	for(iMiddle=0;iMiddle<4;iMiddle++){
		for(jMiddle=0;jMiddle<3;jMiddle++){
			FlangeOffset[jMiddle][iMiddle]=offset[jMiddle][iMiddle];
		}
	}


	RETURNID_OK;
}

RETURN_ID* ManipulatorCommonInterface_MiddleSVC_impl::setMaxSpeedCartesian(const CartesianSpeed& speed)
{
	for(iMiddle=0;iMiddle<13;iMiddle++){
		BufMiddle[iMiddle]=0.0;
	}
	BufMiddle[0]=224;
	BufMiddle[1]=speed.translation;
	BufMiddle[2]=speed.rotation;

	//100{đM
	for(iMiddle=1;iMiddle<3;iMiddle++){
		BufMiddle[iMiddle]=BufMiddle[iMiddle]*100;
	}
	Message(BufMiddle);

	MaxCV.translation=speed.translation;
	MaxCV.rotation=speed.rotation;

	RETURNID_OK;
}

RETURN_ID* ManipulatorCommonInterface_MiddleSVC_impl::setMaxSpeedJoint(const DoubleSeq& speed)
{
	for(iMiddle=0;iMiddle<13;iMiddle++){
		BufMiddle[iMiddle]=0.0;
	}
	BufMiddle[0]=225;
	for(iMiddle=0;iMiddle<7;iMiddle++){
		BufMiddle[iMiddle+1]=speed[iMiddle];
	}

	//100{đM
	for(iMiddle=1;iMiddle<7;iMiddle++){
		BufMiddle[iMiddle]=BufMiddle[iMiddle]*100;
	}
	Message(BufMiddle);

	for(iMiddle=0;iMiddle<7;iMiddle++){
		MaxJV[iMiddle]=speed[iMiddle];
	}

	RETURNID_OK;
}

RETURN_ID* ManipulatorCommonInterface_MiddleSVC_impl::setMinAccelTimeCartesian(CORBA::Double aclTime)
{
	for(iMiddle=0;iMiddle<13;iMiddle++){
		BufMiddle[iMiddle]=0.0;
	}
	BufMiddle[0]=226;
	BufMiddle[1]=aclTime;

	//100{đM
	BufMiddle[1]=BufMiddle[1]*100;
	Message(BufMiddle);

	MinAccelTimeC=aclTime;

	RETURNID_OK;
}

RETURN_ID* ManipulatorCommonInterface_MiddleSVC_impl::setMinAccelTimeJoint(CORBA::Double aclTime)
{
	for(iMiddle=0;iMiddle<13;iMiddle++){
		BufMiddle[iMiddle]=0.0;
	}
	BufMiddle[0]=227;
	BufMiddle[1]=aclTime;

	//100{đM
	BufMiddle[1]=BufMiddle[1]*100;
	Message(BufMiddle);

	MinAccelTimeJ=aclTime;

	RETURNID_OK;
}

RETURN_ID* ManipulatorCommonInterface_MiddleSVC_impl::setSoftLimitCartesian(const LimitValue& xLimit, const LimitValue& yLimit, const LimitValue& zLimit)
{
	for(iMiddle=0;iMiddle<13;iMiddle++){
		BufMiddle[iMiddle]=0.0;
	}
	BufMiddle[0]=228;
	BufMiddle[1]=xLimit.upper;
	BufMiddle[2]=xLimit.lower;
	BufMiddle[3]=yLimit.upper;
	BufMiddle[4]=yLimit.lower;
	BufMiddle[5]=zLimit.upper;
	BufMiddle[6]=zLimit.lower;

	//100{đM
	for(iMiddle=1;iMiddle<7;iMiddle++){
		BufMiddle[iMiddle]=BufMiddle[iMiddle]*100;
	}
	Message(BufMiddle);

	MaxLimitX=xLimit.upper;
	MinLimitX=xLimit.lower;
	MaxLimitY=yLimit.upper;
	MinLimitY=yLimit.lower;
	MaxLimitZ=zLimit.upper;
	MinLimitZ=zLimit.lower;

	RETURNID_OK;
}

RETURN_ID* ManipulatorCommonInterface_MiddleSVC_impl::setSpeedCartesian(ULONG spdRatio)
{
	for(iMiddle=0;iMiddle<13;iMiddle++){
		BufMiddle[iMiddle]=0.0;
	}
	BufMiddle[0]=229;
	BufMiddle[1]=spdRatio;
	
	if(BufMiddle[1]>100){
		//s
		RETURNID_VALUE_ERR;
	}

	//100{đM
	BufMiddle[1]=BufMiddle[1]*100;
	Message(BufMiddle);
	RETURNID_OK;
}

RETURN_ID* ManipulatorCommonInterface_MiddleSVC_impl::setSpeedJoint(ULONG spdRatio)
{
	for(iMiddle=0;iMiddle<13;iMiddle++){
		BufMiddle[iMiddle]=0.0;
	}
	BufMiddle[0]=230;
	BufMiddle[1]=spdRatio;

	if(BufMiddle[1]>100){
		//s
		RETURNID_VALUE_ERR;
	}

	//100{đM
	BufMiddle[1]=BufMiddle[1]*100;
	Message(BufMiddle);
	RETURNID_OK;
}

RETURN_ID* ManipulatorCommonInterface_MiddleSVC_impl::moveCircularCartesianAbs(const CarPosWithElbow& carPointR, const CarPosWithElbow& carPointT)
{
	for(iMiddle=0;iMiddle<13;iMiddle++){
		BufMiddle[iMiddle]=0.0;
	}
	BufMiddle[0]=231;

	BufMiddle[1]=carPointR.carPos[0][3];//x1
	BufMiddle[2]=carPointR.carPos[1][3];//y1
	BufMiddle[3]=carPointR.carPos[2][3];//z1

	/*
	BufMiddle[5]=asin(-carPointR.carPos[0][2])*180.0/M_PI;//B1[deg]
	if((BufMiddle[5]==90)||(BufMiddle[5]==-90)){
		
		RETURNID_VALUE_ERR;

	}else{
		BufMiddle[4]=atan2(carPointR.carPos[1][2],carPointR.carPos[2][2])*180.0/M_PI;//A1[deg]
		BufMiddle[6]=atan2(carPointR.carPos[0][1],carPointR.carPos[0][0])*180.0/M_PI;//C1[deg]
	}
	*/
	BufMiddle[5]=180.0-asin(-carPointR.carPos[0][2])*180.0/M_PI;//B1(90`180deg͈̔)

	if(fabs(BufMiddle[5])==90){
		BufMiddle[4]=0.0;//A1[deg]
		BufMiddle[6]=atan2(carPointR.carPos[1][1],carPointR.carPos[0][1])*180.0/M_PI;//C1[deg]
	}else{
		BufMiddle[4]=atan2(carPointR.carPos[1][2],carPointR.carPos[2][2])*180.0/M_PI;//A1[deg]
		BufMiddle[6]=atan2(carPointR.carPos[0][1],carPointR.carPos[0][0])*180.0/M_PI;//C1[deg]
	}

	BufMiddle[7]=carPointT.carPos[0][3];//x2
	BufMiddle[8]=carPointT.carPos[1][3];//y2
	BufMiddle[9]=carPointT.carPos[2][3];//z2

	/*
	BufMiddle[11]=asin(-carPointT.carPos[0][2])*180.0/M_PI;//B2[deg]
	if((BufMiddle[11]==90)||(BufMiddle[11]==-90)){
		
		RETURNID_VALUE_ERR;

	}else{
		BufMiddle[10]=atan2(carPointT.carPos[1][2],carPointT.carPos[2][2])*180.0/M_PI;//A2[deg]
		BufMiddle[12]=atan2(carPointT.carPos[0][1],carPointT.carPos[0][0])*180.0/M_PI;//C2[deg]
	}
	*/
	BufMiddle[11]=180.0-asin(-carPointT.carPos[0][2])*180.0/M_PI;//B2(90`180deg͈̔)

	if(fabs(BufMiddle[11])==90){
		BufMiddle[10]=0.0;//A2[deg]
		BufMiddle[12]=atan2(carPointT.carPos[1][1],carPointT.carPos[0][1])*180.0/M_PI;//C2[deg]
	}else{
		BufMiddle[10]=atan2(carPointT.carPos[1][2],carPointT.carPos[2][2])*180.0/M_PI;//A2[deg]
		BufMiddle[12]=atan2(carPointT.carPos[0][1],carPointT.carPos[0][0])*180.0/M_PI;//C2[deg]
	}

	//100{đM
	for(iMiddle=1;iMiddle<13;iMiddle++){
		BufMiddle[iMiddle]=BufMiddle[iMiddle]*100;
	}

	Message(BufMiddle);
	RETURNID_OK;
}

RETURN_ID* ManipulatorCommonInterface_MiddleSVC_impl::moveCircularCartesianRel(const CarPosWithElbow& carPointR, const CarPosWithElbow& carPointT)
{
	for(iMiddle=0;iMiddle<13;iMiddle++){
		BufMiddle[iMiddle]=0.0;
	}
	BufMiddle[0]=232;

	BufMiddle[1]=carPointR.carPos[0][3];//x1
	BufMiddle[2]=carPointR.carPos[1][3];//y1
	BufMiddle[3]=carPointR.carPos[2][3];//z1

	/*
	BufMiddle[5]=asin(-carPointR.carPos[0][2])*180.0/M_PI;//B1[deg]
	if((BufMiddle[5]==90)||(BufMiddle[5]==-90)){
		
		RETURNID_VALUE_ERR;

	}else{
		BufMiddle[4]=atan2(carPointR.carPos[1][2],carPointR.carPos[2][2])*180.0/M_PI;//A1[deg]
		BufMiddle[6]=atan2(carPointR.carPos[0][1],carPointR.carPos[0][0])*180.0/M_PI;//C1[deg]
	}
	*/
	BufMiddle[5]=180.0-asin(-carPointR.carPos[0][2])*180.0/M_PI;//B1(90`180deg͈̔)

	if(fabs(BufMiddle[5])==90){
		BufMiddle[4]=0.0;//A1[deg]
		BufMiddle[6]=atan2(carPointR.carPos[1][1],carPointR.carPos[0][1])*180.0/M_PI;//C1[deg]
	}else{
		BufMiddle[4]=atan2(carPointR.carPos[1][2],carPointR.carPos[2][2])*180.0/M_PI;//A1[deg]
		BufMiddle[6]=atan2(carPointR.carPos[0][1],carPointR.carPos[0][0])*180.0/M_PI;//C1[deg]
	}

	BufMiddle[7]=carPointT.carPos[0][3];//x2
	BufMiddle[8]=carPointT.carPos[1][3];//y2
	BufMiddle[9]=carPointT.carPos[2][3];//z2

	/*
	BufMiddle[11]=asin(-carPointT.carPos[0][2])*180.0/M_PI;//B2[deg]
	if((BufMiddle[11]==90)||(BufMiddle[11]==-90)){
		
		RETURNID_VALUE_ERR;

	}else{
		BufMiddle[10]=atan2(carPointT.carPos[1][2],carPointT.carPos[2][2])*180.0/M_PI;//A2[deg]
		BufMiddle[12]=atan2(carPointT.carPos[0][1],carPointT.carPos[0][0])*180.0/M_PI;//C2[deg]
	}
	*/

	BufMiddle[11]=180.0-asin(-carPointT.carPos[0][2])*180.0/M_PI;//B2(90`180deg͈̔)

	if(fabs(BufMiddle[11])==90){
		BufMiddle[10]=0.0;//A2[deg]
		BufMiddle[12]=atan2(carPointT.carPos[1][1],carPointT.carPos[0][1])*180.0/M_PI;//C2[deg]
	}else{
		BufMiddle[10]=atan2(carPointT.carPos[1][2],carPointT.carPos[2][2])*180.0/M_PI;//A2[deg]
		BufMiddle[12]=atan2(carPointT.carPos[0][1],carPointT.carPos[0][0])*180.0/M_PI;//C2[deg]
	}

	//100{đM
	for(iMiddle=1;iMiddle<13;iMiddle++){
		BufMiddle[iMiddle]=BufMiddle[iMiddle]*100;
	}

	Message(BufMiddle);
	RETURNID_OK;
}

RETURN_ID* ManipulatorCommonInterface_MiddleSVC_impl::setHome(const JointPos& jointPoint)
{
	for(iMiddle=0;iMiddle<13;iMiddle++){
		BufMiddle[iMiddle]=0.0;
	}
	BufMiddle[0]=233;
	for(iMiddle=0;iMiddle<6;iMiddle++){
		BufMiddle[iMiddle+1]=jointPoint[iMiddle];
		HomePoint[iMiddle]=jointPoint[iMiddle];
	}

	//100{đM
	for(iMiddle=1;iMiddle<7;iMiddle++){
		BufMiddle[iMiddle]=BufMiddle[iMiddle]*100;
	}
	Message(BufMiddle);

	RETURNID_OK;
}

RETURN_ID* ManipulatorCommonInterface_MiddleSVC_impl::getHome(JointPos_out jointPoint)
{
	jointPoint=new JointPos;
	jointPoint->length(6);
	for(iMiddle=0;iMiddle<6;iMiddle++){
		(*jointPoint)[iMiddle]=HomePoint[iMiddle];
	}
	RETURNID_OK;
}

RETURN_ID* ManipulatorCommonInterface_MiddleSVC_impl::goHome()
{
	for(iMiddle=0;iMiddle<13;iMiddle++){
		BufMiddle[iMiddle]=0.0;
	}
	BufMiddle[0]=235;
	Message(BufMiddle);
	RETURNID_OK;
}



// End of example implementational code



